c SuperAutoDipole by Kouhei Hasegawa, 2010
c Filename:check_susy.f
c Program: check of the code on user's machine against the analytical result
c input  :5 randomly chosen phase space points in inputm.h
c output :the values of |M(real)|^2 and Dipole terms
c 
      program checkdipole
      implicit none

      integer i,k
      double precision p(0:3,1:5),dip(2),SumD,msq,acc,m2,AL,ratio,mt,mb
      double precision msg,msul,msur,msdl,msdr,mssl,mssr,mscl,mscr
      double precision mst1,mst2,msb1,msb2
      double precision s12,s13,s14,s15,s23,s24,s25,s34,s35,s45,dot
      double precision fac1,piv,ALew,Msq_a,m
      double precision fac_b1,b1_a,fac_dip1,dip1_a,s345
      double precision fac_b2,b2_a,fac_dip2,dip2_a,SumD_a
      character checkmsq*13,checkD*13
      common /INPUTM/ p
      common /MADMS/ m2
      common /usedalpha/ AL
      common /MASS/ mt,mb
      common /SUSYMASS/ msg,msul,msur,msdl,msdr,mssl,mssr,mscl,mscr,
     &mst1,mst2,msb1,msb2
      include 'coupl.inc'
      include 'nexternal.inc'
      call setpara('param_card.dat',.true.)
      AL=g**2*(4.d0*3.141592653589793238D0)**(-1)
      checkmsq='Confirmed'
      checkD='Confirmed'
      mt=tmass
      mb=bmass
      msg=mgo
      msul=mul
      msur=mur
      msdl=mdl
      msdr=mdr
      mssl=msl
      mssr=msr
      mscl=mcl
      mscr=mcr
      mst1=mt1
      mst2=mt2
      msb1=mb1
      msb2=mb2
      m=mst1
      piv=3.141592653589793238D0
      ALew=gal(1)**2*(4*piv)**(-1)
c      write(*,*) '          |M|^2                      SumDipole
c     &          |M|^2 - SumDipole'
       
      write(*,*) '-----------------------------------'
      write(*,*) 'Check_SUSY at process e-e+_t1t1xg'
      write(*,*) '-----------------------------------'
      write(*,*) '          |M|^2                      |M|^2(Analytical)
     &          Ratio                      Accuracy'
      do i=1,5
       call readmomenta
       call smatrix(p,msq)
       s12=2.d0*dot(p(0,1),p(0,2))
       s13=2.d0*dot(p(0,1),p(0,3))
       s14=2.d0*dot(p(0,1),p(0,4))
       s15=2.d0*dot(p(0,1),p(0,5))
       s23=2.d0*dot(p(0,2),p(0,3))
       s24=2.d0*dot(p(0,2),p(0,4))
       s25=2.d0*dot(p(0,2),p(0,5))
       s34=2.d0*dot(p(0,3),p(0,4))
       s35=2.d0*dot(p(0,3),p(0,5))
       s45=2.d0*dot(p(0,4),p(0,5))

       fac1= 2*m**4*s12*(s35 + s45)**2 + 
     -  s12*s35*s45*(-2*s14**2 - 2*s14*s15 + 
     -     s12*(2*s14 + s15 - s45) + s14*s45 + s35*(-s14 - s15 + s45))
     -    - 2*m**2*(-((s14 + s15)**2*s35**2) + s12**2*s35*s45 - 
     -     2*s14*(s14 + s15)*s35*s45 - s14**2*s45**2 + 
     -     s12*(s35**2*(s14 + s15 - s45) + 
     -        s35*(2*s14 + s15 - s45)*s45 + s14*s45**2))

       msq_a=256.d0*16.d0*9.d0**(-1)*piv**3*ALew**2*AL*
     &(s12*s35*s45)**(-2)*fac1
       call accuracy(msq,msq_a,ratio,acc)
       write(*,'(1x,i3,1x,4e27.15)') i, msq,msq_a,ratio,acc
       if ( dabs(acc) .gt. 1.d-13) then
         checkmsq='Not confirmed'
       endif
       enddo
       write(*,*) ' '
      write(*,*) '          SumDipole                  SumDipole(Analyti
     &cal)      Ratio                      Accuracy'
      do i=1,5
       call readmomenta
       call dipole(p,dip,SumD)
       s12=2.d0*dot(p(0,1),p(0,2))
       s13=2.d0*dot(p(0,1),p(0,3))
       s14=2.d0*dot(p(0,1),p(0,4))
       s15=2.d0*dot(p(0,1),p(0,5))
       s23=2.d0*dot(p(0,2),p(0,3))
       s24=2.d0*dot(p(0,2),p(0,4))
       s25=2.d0*dot(p(0,2),p(0,5))
       s34=2.d0*dot(p(0,3),p(0,4))
       s35=2.d0*dot(p(0,3),p(0,5))
       s45=2.d0*dot(p(0,4),p(0,5))
       s345=s34+s35+s45

       fac_b1=        -4*m**2*s12 + s12**2 - 
     -  (4*(-4*m**4 + s345**2)*
     -     (s14 - (s12*(2*m**2 + s345 - s35))/
     -         (4*m**2 + 2*s345))**2)/
     -   ((2*m**2 + s345)*(-2*m**2 + s345 - 2*s35) + s35**2)
       b1_a=-128.d0*9.d0**(-1)*piv**2*ALew**2*s12**(-2)*fac_b1
       fac_dip1= -(((2 + (2*m**2)/s35)*(s345 - s35)*
     -       Sqrt((-4*m**4 + s345**2)/
     -         (-4*m**4 + (s345 - s35)**2 - 4*m**2*s35)))
     -      /s345) + (2*s345)/(s35 + s45)
       dip1_a=-8.d0*piv*AL*s35**(-1)*fac_dip1*b1_a

      fac_b2=        -4*m**2*s12 + s12**2 - 
     -  (4*(-4*m**4 + s345**2)*
     -     (s23 - (s12*(2*m**2 + s345 - s45))/(4*m**2 + 2*s345))**2)/
     -   ((2*m**2 + s345)*(-2*m**2 + s345 - 2*s45) + s45**2)
      b2_a=-128.d0*9.d0**(-1)*piv**2*ALew**2*s12**(-2)*fac_b2
      fac_dip2=        (2*s345)/(s35 + s45) - 
     -  ((2 + (2*m**2)/s45)*(s345 - s45)*
     -     Sqrt((-4*m**4 + s345**2)/
     -       (-4*m**4 + (s345 - s45)**2 - 4*m**2*s45)))/s345
      dip2_a=-8.d0*piv*AL*s45**(-1)*fac_dip2*b2_a
      SumD_a=dip1_a+dip2_a
       call accuracy(SumD,SumD_a,ratio,acc)
       write(*,'(1x,i3,1x,4e27.15)') i,SumD,SumD_a,ratio,acc
       if ( dabs(acc) .gt. 1.d-12) then
         checkD='Not confirmed'
       endif
       enddo     

      open(Unit=3,File='../res_check_susy',Status='old',access='append')
      write(3,*) 'e-e+_t1t1xg'
      write(3,*) '  |M|^2(Real) :', checkmsq
      write(3,*) '   Dipole     :',checkD
      close(unit=3)
      end
       
       
      subroutine readmomenta
      implicit none
      integer idy1
      double precision m2
      double precision p(0:3,1:5)
      common /INPUTM/ p
      common /MADMS/ m2
       
      open (unit=11, file ='inputm.h', status = 'old')
      read  (11,*) idy1, p(0,1), p(1,1), p(2,1), p(3,1)
      read  (11,*) idy1, p(0,2), p(1,2), p(2,2), p(3,2)
      read  (11,*) idy1, p(0,3), p(1,3), p(2,3), p(3,3)
      read  (11,*) idy1, p(0,4), p(1,4), p(2,4), p(3,4)
      read  (11,*) idy1, p(0,5), p(1,5), p(2,5), p(3,5)
      read  (11,*) m2  

      return
      end

      subroutine accuracy(standard,objective,ratio,acc)
      implicit none
      double precision standard,objective,ratio,acc
      ratio = objective/standard
      acc = (standard - objective)/standard
      return
      end

       
