c SuperAutoDipole by Kouhei Hasegawa, 2010
c Kouhei Hasegawa, 2010
c Filename:check_susy2.f
c
c Program: checkdipole checks whether the generated values of |M(real)|^2 and 
c          dipole terms on an user machine agree with the default values.
c          This program is uded by the command, check.sh
c
c input : default momentum and the values of |M|^2 and dipole terms in inputm_std.h
c output: file res_check: the reults of checks
c
c Subroutine: readmomentado reads the input values of momentum, |M(real)|^2 and dipole terms
c             from inputm_std.h
c
      program checkdipole
      implicit none

      integer i,k
      double precision p(0:3,1:5),dip(12),SumD,msq,acc,m2,AL,ratio,mt,mb
      double precision msg,msul,msur,msdl,msdr,mssl,mssr,mscl,mscr
      double precision mst1,mst2,msb1,msb2,dip_std
      character checkmsq*13,checkD*13
      common /INPUTM/ p
      common /MADMS/ m2,dip_std
      common /usedalpha/ AL
      common /MASS/ mt,mb
      common /SUSYMASS/ msg,msul,msur,msdl,msdr,mssl,mssr,mscl,mscr,
     &mst1,mst2,msb1,msb2
      include 'coupl.inc'
      include 'nexternal.inc'
      call setpara('param_card.dat',.true.)

      checkmsq='Confirmed'
      checkD='Confirmed'

      AL=g**2*(4.d0*3.141592653589793238D0)**(-1)
      mt=tmass
      mb=bmass
      msg=mgo
      msul=mul
      msur=mur
      msdl=mdl
      msdr=mdr
      mssl=msl
      mssr=msr
      mscl=mcl
      mscr=mcr
      mst1=mt1
      mst2=mt2
      msb1=mb1
      msb2=mb2
      write(*,*) '          |M|^2                      |M|^2(Standard)
     &          Ratio                      Accuracy'
       
      do i=1,5
       call readmomentado
       call smatrix(p,msq)
       call accuracy(msq,m2,ratio,acc)
       write(*,'(1x,i3,1x,4e27.15)') i, msq,m2,ratio,acc
       if ( dabs(acc) .gt. 1.d-13) then
         checkmsq='Not confirmed'
       endif
      enddo

      close (unit=11)
      write(*,*) ' '

      write(*,*) '          SumDipole                  SumDipole(Standar
     &d)        Ratio                      Accuracy'

      do i=1,5
       call readmomentado
       call dipole(p,dip,SumD)
       call accuracy(SumD,dip_std,ratio,acc)
       write(*,'(1x,i3,1x,4e27.15)') i,SumD,dip_std,ratio,acc
       if ( dabs(acc) .gt. 1.d-12) then
         checkD='Not confirmed'
       endif
      enddo

      open(Unit=3,File='../res_check_susy',Status='old',access='append')
      write(3,*) 'gg_t1t1xg'
      write(3,*) '  |M|^2(Real) :', checkmsq
      write(3,*) '   Dipole     :',checkD
      close(unit=3)
      end
       
       
      subroutine readmomentado
      implicit none
      integer idy1
      double precision m2,dip_std
      double precision p(0:3,1:5)
      common /INPUTM/ p
      common /MADMS/ m2,dip_std
       
      open (unit=11, file ='inputm_std.h', status = 'old')
      read  (11,*) idy1, p(0,1), p(1,1), p(2,1), p(3,1)
      read  (11,*) idy1, p(0,2), p(1,2), p(2,2), p(3,2)
      read  (11,*) idy1, p(0,3), p(1,3), p(2,3), p(3,3)
      read  (11,*) idy1, p(0,4), p(1,4), p(2,4), p(3,4)
      read  (11,*) idy1, p(0,5), p(1,5), p(2,5), p(3,5)
      read  (11,*) m2  
      read  (11,*) dip_std
      return
      end
       

      subroutine accuracy(standard,objective,ratio,acc)
      implicit none
      double precision standard,objective,ratio,acc
      ratio = objective/standard
      acc = (standard - objective)/standard
      return
      end

