(* ::Package:: *)

(* AutoDipole - Package of an automated dipole subtraction by
Kouhei Hasegawa, Sven Moch, and Peter Uwer, 2009 *)


(* SuperAutoDipole - MSSM extension by Kouhei Hasegawa, 2010 *)


(* Filename:driver.m  :driver of the package *)


CreateAll[ilist_,flist_]:=Module[{},
Realprocess[ilist,flist];
VirtualCreation;
PDFfactorizationCreation;
printsummary;
];


(* Real part: Dipole tems creation *)
Realprocess[ilist_,flist_]:=Module[{},
Print["-----[Start Dipole creation]-----"];
(*Print["(ilist,flist)=",ilist,flist];*)
<<dipole.m;
Dipole[ilist,flist];
<<dipolefortran.m;
<<shellformad.m;
(*Print["I am Dipolefortran"];*)
Dipolefortran;
(*<<shellformad.m;*)
createcolor;
createamplitude;
createemitspecinfo;
createnexternal;
writecheck;
writecheckIR;
writeirsafe;
Print["-----[End Dipole creation]-----\n\n"];
];


(* Virtual part: I-tem creation *)
VirtualCreation:=Module[{},
Print["-----[Start Virtual creation]-----"];
(*If[dAs >=1,*)
If[dAstotal >=1,
Virtualprocess[ilist_,flist_]:=Module[{},
<<virtual.m;
Itermcreation[ilist,flist];
<<virtualfortran.m;
Virtualfortran;
Print["-----[End Virtual creation]-----\n\n"];
];
Virtualprocess[{A[1],A[2]},A1];,
Print["No B1 exists"];
];
];


(* PDF factorization part: P and K-tems creation *)
PDFfactorizationCreation:=Module[{},
Print["-----[Start P and K creation]-----"];
If[pkexist >= 1,
<<PDFfactorization.m;
PandKtermscreation;
<<PDFfactorizationfortran.m;
PandKtermsfortran;
,Print["No P and K term exists"];
];
Print["-----[End P and K creation]-----\n\n"];
];
