#!/bin/sh
#
# SuperAutoDipole by Kouhei Hasegawa, 2010
# Shell script to check a SUSY standard candle process on the user machine

echo 'Check_SUSY is starting'
HOMEPATH=`pwd`
echo 'Package home'
echo $HOMEPATH
LIBPATH=$HOMEPATH/lib
echo 'lib directory'
echo $LIBPATH
PROCESSPATH=$HOMEPATH/process
echo 'process directory'
echo $PROCESSPATH

MadVersion=MadEvent

sleep 2
echo ' '
echo 'Run of the generated fortran code'
echo ' '
rm -f $PROCESSPATH/res_check_susy
touch -f $PROCESSPATH/res_check_susy



echo 'Start check_susy'
echo '[Proc_e-e+_t1t1xg]'
echo ' '
rm -f $PROCESSPATH/Proc_e-e+_t1t1xg

cp -f $LIBPATH/check/check_susy_e-e+_t1t1xg/parameter.m $HOMEPATH/parameter.m
cp -f $LIBPATH/check/check_susy_e-e+_t1t1xg/interactions.dat $HOMEPATH/patch/Models/mssm/
cp -f $LIBPATH/check/check_susy_e-e+_t1t1xg/param_card.dat $HOMEPATH/patch/Models/mssm/
cd $HOMEPATH
math << EOF
<<driver_user.m
GenerateAll[{e, ebar}, {st1, st1bar, g}]
Quit
EOF
echo ' '
echo '[Proc_e-e+_t1t1xg] Run Fortran code'
echo ' '
cd $PROCESSPATH/Proc_e-e+_t1t1xg
cp $LIBPATH/check/check_susy_e-e+_t1t1xg/check_susy.f ./
mv -f check.f check_save.f
cp -f check_susy.f check.f
make runD
./runD >| res_std
more res_std
mv -f check_save.f check.f
echo 'End check [Proc_e-e+_t1t1xg]'
echo ' '

echo '[Proc_gg_t1t1xg]'
echo ' '
cd $HOMEPATH
math << EOF
<<driver_user.m
GenerateAll[{g, g}, {st1, st1bar, g}]
Quit
EOF
echo ' '
echo '[Proc_gg_t1t1xg] Run Fortran code'
echo ' '
cd $PROCESSPATH/Proc_gg_t1t1xg
cp -f $LIBPATH/check/check_susy_gg_t1t1xg/check_susy2.f ./
cp -f $LIBPATH/check/check_susy_gg_t1t1xg/inputm_gg_t1t1xg.h ./inputm_std.h
mv -f check.f check_save.f
cp -f check_susy2.f check.f
make runD
./runD >| res_std
more res_std
mv -f check_save.f check.f
echo 'End check [Proc_gg_t1t1xg]'
echo ' '

cp -f $HOMEPATH/$MadVersion/Models/sm/interactions.dat $HOMEPATH/patch/Models/sm/interactions.dat
cp -f $HOMEPATH/$MadVersion/Models/sm/param_card.dat $HOMEPATH/patch/Models/sm/param_card.dat
cp -f $LIBPATH/math/parameter_default.m $HOMEPATH/parameter.m

echo ' '
echo '********************************'
echo 'Check_susy results'
more $PROCESSPATH/res_check_susy
echo 'End'
echo '********************************'


